﻿$(init);
function init() {
	
	//девайсы устанавливаемые по умолчанию
	var default_devices_map = [];
	for(var i=0;i<devices.length;i++) if(devices[i].installed_in_segments) default_devices_map.push(i);

	var device_dependences = [];
	/*индекс в массиве = индексу девайса в dataset.
	В качестве данных - массив ссылок на девайсы в 
	dataset, которые контроллируются индексным девайсом*/
	for(var i=0;i<devices.length;i++){ // индексные девайсы
		var tdl = devices.length;
		var tel = tdl + engines.length;
		var tbl = tel + batteries.length;
		var twl = tbl + weapons.length;
		for(var j=0;j<twl;j++){ // поиск контроллируемых девайсов
			var td= j<tdl? devices[j]:
					j<tel? engines[j-tdl].device:
					j<tbl? batteries[j-tel].device: weapons[j-tbl].device;
			var tcds = td.controlled_by_devices;
			if(i!=j && tcds) 
			for(var k=0;k<tcds.length;k++) for(var l=0;l<tcds[k].length;l++){ // контроллирующиe девайсов
				if(tcds[k][l]==i){
					if(device_dependences[i]) device_dependences[i].push(j);
					else device_dependences[i]=[j];
				}
			}
		}
	}
	
	//хтмл-элементы
	var mods_holder = $("#mods_holder");
	var menu_options = $(".menu_choice");
	var work_area = $("#mech_builder_work_area");
	var segments_holder_element = $(".segments_holder");
	
	var m_rename_element = $("#mech_rename_element");
	var structure_list_element = $("#structure_choice");
	var rk_choice_element = $("#rk_choice");
	var material_choice_element = $("#material_choice");
	var engine_choice_element = $("#engine_choice");
	var device_choice_element = $("#device_choice");
	var battery_choice_element = $("#battery_choice");
	var weapon_choice_element = $("#weapon_choice");
	var plate1_choice_element = $("#plate1_choice");
	var plate2_choice_element = $("#plate2_choice");
	var plate3_choice_element = $("#plate3_choice");
	var armor_shield_choice_element = $("#armor_shield_choice");
	
	var characteristics_elements = [
		$("#unit_name"),
		$("#structure_name"),
		$("#rk_value"),
		$("#material_type"),
		$("#safety_warming_value"),
		$("#control_lock_threshold"),
		$("#engines_workload"),
		$("#power_threshold"),
		$("#total_weight"),
		$("#vacant_weight"),
		$("#unit_speed"),
		$("#unit_capacity"),
		$("#total_price"), 
		$("#massive_damage"),
		$("#battery_load"),
		$("#bmd")
		//...
	];
	var status_elements = [
		[$("#unit_name_status .ok_status"),$("#unit_name_status .warning_status")],
		[$("#structure_status .ok_status"),$("#structure_status .warning_status")],
		[$("#rk_status .ok_status"),$("#rk_status .warning_status")],
		[$("#material_status .ok_status"),$("#material_status .warning_status")],
		[$("#safety_warming_status .ok_status"),$("#safety_warming_status .warning_status")],
		[$("#control_lock_threshold_status .ok_status"),$("#control_lock_threshold_status .warning_status")],
		[$("#engines_workload_status .ok_status"),$("#engines_workload_status .warning_status")],
		[$("#power_threshold_status .ok_status"),$("#power_threshold_status .warning_status")],
		[$("#total_weight_status .ok_status"),$("#total_weight_status .warning_status")],
		[$("#vacant_weight_status .ok_status"),$("#vacant_weight_status .warning_status")],
		[$("#unit_speed_status .ok_status"),$("#unit_speed_status .warning_status")],
		[$("#unit_capacity_status .ok_status"),$("#unit_capacity_status .warning_status")],
		[$("#unit_total_price_status .ok_status"),$("#unit_total_price_status .warning_status")],
		[$("#massive_damage_status .ok_status"),$("#massive_damage_status .warning_status")],
		[$("#battery_load_status .ok_status"),$("#battery_load_status .warning_status")],
		[$("#bmd_status .ok_status"),$("#bmd_status .warning_status")]
	];
	
	//MVC
	var m_gui = new MGui(
		structure_list_element,
		status_elements,
		characteristics_elements,
		segments_holder_element,
		material_choice_element,
		mods_holder,
		engine_choice_element,
		device_choice_element,
		battery_choice_element,
		weapon_choice_element,
		plate1_choice_element, 
		plate2_choice_element, 
		plate3_choice_element, 
		armor_shield_choice_element);
	var custom_mech = new MUnitBuilder(default_devices_map,device_dependences);
	var m_controller = new MManager(custom_mech, m_gui);
	//
	/*$("#bmdlt").click(function(e){m_controller.previous_generator();});
	$("#bmdrt").click(function(e){m_controller.next_generator();});
	$("#bmd_label").click(function(e){m_controller.justify_bmd();});*/
	plate2_choice_element.click(function(e){m_controller.put_armorplate2(e);});
	plate3_choice_element.click(function(e){m_controller.put_armorplate3(e);});
	armor_shield_choice_element.click(function(e){m_controller.put_armorshield(e);});
	plate1_choice_element.click(function(e){m_controller.put_armorplate1(e);});
	weapon_choice_element.click(function(e){m_controller.put_weapon(e);});
	battery_choice_element.click(function(e){m_controller.put_battery(e);});
	device_choice_element.click(function(e){m_controller.put_device(e,0);});
	engine_choice_element.click(function(e){m_controller.put_engine(e);});
	mods_holder.click(function(e){m_controller.parse_click(e.target);});
	segments_holder_element.click(function(e){m_gui.unselect_mod_details(); m_controller.parse_click(e.target);});
	material_choice_element.click(function(e){m_controller.set_model_material(e);});
	rk_choice_element.click(function(e){m_controller.set_model_rk(e);});
	structure_list_element.click(function(e){m_controller.set_model_structure(e);});
	work_area.click(function(){m_gui.unselect_menu();});
	$("form").submit(function(){return false;});
	menu_options.click(function(){
		m_gui.show_selected_choice($(this));});
	m_rename_element.keydown(function(e){
		if(e.keyCode==13){m_controller.set_model_name($(this).attr("value"));}});
}